/* MA1DTEST - a Rexx/MQ/Netview Example */

/* Initialise the interface */
RXMQWTRACE = ''

rcc= RXMQW('INIT')
say 'rc=' rcc

/* Connect to Queue Manager - VRH1 */

RXMQWTRACE = ''
rcc = RXMQW('CONN', 'VRH1')
say 'RC=' rcc

/* Open Queue N1 for Inquire Access Only, tracing OD accesses */

iod.on = 'N1'
iod.ot = MQOT_Q

RXMQWTRACE = 'BOD MOD'
rcc = RXMQW('OPEN', 'iod.', mqoo_inquire, 'h1', 'ood.')
say 'RC=' rcc  'H=' h1

/* Open Queue P1 for Output and Browse Access, plus Attr manipulation */

RXMQWTRACE = ''
oo = mqoo_inquire+mqoo_output+mqoo_browse+mqoo_set
rcc = RXMQW('OPEN', 'P1', oo , 'h2', 'ood.' )
say 'RC=' rcc  'H=' h2

/* Write a Persistent Message, within UOW, to Queue P1; trace everything */

RXMQWTRACE = 'PUT BMD MMD MPO BPO'
d.0      = 20
d.1      = time() '0123456789'
imd.PER  = MQPER_PERSISTENT
ipmo.opt = MQPMO_SYNCPOINT
rcc      = RXMQW('PUT', h2,'d.','imd.','omd.','ipmo.','opmo.')
say 'RC=' rcc

/* Inquire upon the number of Messages now in Queue P1 */

RXMQWTRACE = ''
atrin = mqia_current_q_depth
atrou = ''
rcc   = RXMQW('INQ', h2, atrin, 'atrou' )
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'

/* Show the name of the Queue which is using handle 1*/

RXMQWTRACE = ''
atrin = mqca_q_name
atrou = ''
rcc   = RXMQW('INQ', h1, atrin, 'atrou' )
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'
/* Toggle the GETtability of a Queue, providing a change each time */

RXMQWTRACE = ''
atrsn = MQIA_INHIBIT_GET
atrsd = MQQA_GET_INHIBITED
rcc   = RXMQW('SET', h2, atrsn, atrsd)
say 'RC=' rcc

RXMQWTRACE = ''
atrin = mqia_inhibit_get ; atrou = ''
rcc   = RXMQW('INQ', h2, atrin, 'atrou' )
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'

RXMQWTRACE = ''
atrsn = MQIA_INHIBIT_GET
atrsd = MQQA_GET_ALLOWED
rcc   = RXMQW('SET', h2, atrsn, atrsd)
say 'RC=' rcc

RXMQWTRACE = ''
atrin = MQIA_INHIBIT_GET ; atrou = ''
rcc = RXMQW('INQ', h2, atrin, 'atrou' )
say 'RC=' rcc
say 'Atr' atrin 'Setting <'atrou'>'

/* Set the Trigger Data for a Queue ... */

RXMQWTRACE = ''
atrsn = MQCA_TRIGGER_DATA
atrsd = 'RAH Trigger Data'
rcc   = RXMQW('SET', h2, atrsn, atrsd)
say 'RC=' rcc

/* ... and show that it's worked */

RXMQWTRACE = ''
atrin = mqca_trigger_data
atrou = ''
rcc = RXMQW('INQ', h2, atrin, 'atrou' )
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'

/* Syncpoint all accesses to the QM */

RXMQWTRACE = ''
rcc = RXMQW('CMIT', )
say 'RC=' rcc

/* Browse all msgs on queue P1, tracing everything, showing updates */

RXMQWTRACE = 'BGO MGO MMD BMD GET'
do i=1
   g.0      = 200
   g.1      = ''
   igmo.opt = MQGMO_WAIT+MQGMO_BROWSE_NEXT
   rcc = RXMQW('GET',  h2,'g.','igmd.','ogmd.','igmo.','ogmo.')
   say 'RC=' rcc
   say '...............' i 'data <'g.1'> length' g.0
   say 'ogmd.pd' ogmd.pd 'ogmo.rqn<'ogmo.rqn'>'
   if ( word(rcc,1) <> 0 ) then leave
   end

/* Rollback a Unit of Work (empty in this case) */
RXMQWTRACE = ''
rcc = RXMQW('BACK', )
say 'RC=' rcc

/* Stop access to a Queue */

RXMQWTRACE = ''
rcc = RXMQW('CLOSE', h2, mqco_none)
say 'RC=' rcc

/* Re-open the P1 Queue for Browse only access */

RXMQWTRACE = ''
rcc = RXMQW('OPEN', 'P1', mqoo_browse, 'h3', 'ood.')
say 'RC=' rcc  'H=' h3

/* Browse the Queue using the Extension function */
RXMQWTRACE = ''
do i=1
   g.0 = 200
   g.1 = ''
   rcc = RXMQW('BROWSE',  h3,'g.')
   say 'RC=' rcc
   say '@@@@@@@@@@@@@@@' i 'data <'g.1'> length' g.0
   if ( word(rcc,1) <> 0 ) then leave
   end

/* Show the last command used etc. */
say 'Last Message <'RXMQW.LASTMSG'> Last call 'RXMQW.LASTOP,
    ' which ended with RC' RXMQW.LASTRC') and MQCC' RXMQW.LASTCC')',
    ' MQRC' RXMQW.LASTAC')'


/* Issue a Bad command to show effect of -ve RC */
rcc = RXMQW('OPEN', )
say 'Last Message <'RXMQW.LASTMSG'> Last call 'RXMQW.LASTOP,
    ' which ended with RC' RXMQW.LASTRC') and MQCC' RXMQW.LASTCC')',
    ' MQRC' RXMQW.LASTAC')'

/* Stop access to the Queue */

RXMQWTRACE = ''
rcc = RXMQW('CLOSE', h3, mqco_none)
say 'RC=' rcc

/* Disconnect from the QM (Closing h1 in the process) */

RXMQWTRACE = ''
rcc = RXMQW('DISC', )
say 'RC=' rcc

/* Remove the Interface functions from the Rexx Workspace ... */

RXMQWTRACE = 'TERM'
rcc = RXMQW('TERM', )
say 'RC=' rcc

/* ... but leave the MQ_ constants around */
say 'MQPER_PERSISTENT' MQPER_PERSISTENT 'RC(2048) is' RXMQW.RCMAP.2048

/* End of MA1DTEST exec */
